<template>
  <div class="gridCounterparts">
    <header class="header">
      <slot name="heading"/>
    </header>
    <AppTable
      class="tableAnalogs"
      :class="{ '_no-city': !location.id }"
      :table-headings="headings"
      :grid="grid">
      <!-- Ячейки с данными для таблицы -->

      <!--картинка запчасти-->
      <template
        :slot="`unit-${headings[0].name}`"
        slot-scope="{ part }">
        <div class="picture">
          <img
            v-if="part.partImages && part.partImages.length"
            :src="part.partImages[0]"
            :alt="`${part.brand} ${part.vendor_code}`">
          <img
            v-else
            svg-inline
            src="~/assets/svg/redesign/navigation-parts.svg">
        </div>
      </template>

      <!--название бренда + артикул запчасти (для мобилки)-->
      <template
        :slot="`unit-${headings[1].name}`"
        slot-scope="{ part }">
        <flink
          :href="href4Item(part)"
          domain="main"
          target="_blank"
          class="link _fullSEOPath">
          <span class="__hide-shadow __no-wrap">
            {{ part.brand }}
          </span>
          <span class="valueIsMobile">
            , {{ part.vendor_code }}
          </span>
        </flink>
        <span class="__hide-shadow __no-wrap">
          {{ part.brand }}
        </span>
        <div
          class="badge"
          v-if="part.is_tested">
          <span>
            Подтвержденный аналог
          </span>
        </div>
      </template>

      <!--артикул запчасти-->
      <template
        :slot="`unit-${headings[2].name}`"
        slot-scope="{ part }">
        <flink
          :href="href4Item(part)"
          domain="main"
          target="_blank"
          class="link">
          {{ part.vendor_code }}
        </flink>
      </template>

      <!-- название запчасти -->
      <template
        :slot="`unit-${headings[3].name}`"
        slot-scope="{ part }">
        {{ part.part_name }}
      </template>

      <!-- стоимость запчасти -->
      <template
        :slot="`unit-${headings[4].name}`"
        slot-scope="{ part }">
        <div>
          <span class="__no-wrap">{{ part.min_price | spacifyNumber }} -</span>
          <span class="__no-wrap">{{ part.max_price | spacifyNumber }} ₽</span>
        </div>
      </template>

      <!-- счетчик предложений в городе -->
      <template
        :slot="`unit-${headings[5].name}`"
        slot-scope="{ part }">
        <flink
          v-if="part.user_location_count"
          :href="href4Item(part)"
          class="button buttonSellerCounter">
          {{ part.user_location_count | spacifyNumber }}
          {{ part.user_location_count | transChoose([ 'предложение', 'предложения', 'предложений', ]) }}
        </flink>
        <div
          v-else
          class="noResult">Нет предложений</div>
      </template>

      <!-- счетчик предложений в стране -->
      <template
        :slot="`unit-${headings[6].name}`"
        slot-scope="{ part }">
        <div class="valueIsMobile">Всего на портале</div>
        <flink
          :href="`${href4Item(part)}?location=0`"
          class="button buttonSellerCounter">
          {{ part.all_offers_count | spacifyNumber }}
          {{ part.all_offers_count | transChoose(['предложение', 'предложения', 'предложений']) }}
        </flink>
      </template>

    </AppTable>
  </div>
</template>

<script>
import AppTable from '~/components/redesign/app-table/app-table';
import AppButton from '~/components/redesign/app-buttons/app-button';

import { mapState } from 'vuex';
import mapFilters from '~/assets/js/helpers/map-filters';

export default {
  name: 'GridCounterparts',
  components: {
    AppButton,
    AppTable,
  },
  props: {
    grid: {
      type: Object,
      default() {
        return {};
      },
    },
  },
  computed: {
    ...mapState(['location']),
    headings() {
      return [
        {
          name: 'img',
          title: '',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'brand',
          title: 'Производитель',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'vendorCode',
          title: 'Номер',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'partName',
          title: 'Название',
          classes: '__all-wrap',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'price',
          title: 'Стоимость',
          classes: '_align-right',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterLocal',
          title: `Предложения в ${this.location.prepositionalName}`,
          hidden: !this.location.id,
          classes: '',
          sorting: { has: false, criteria: '' },
        },
        {
          name: 'sellerCounterAll',
          title: 'Всего на сайте',
          classes: '',
          sorting: { has: false, criteria: '' },
        },
      ];
    },
  },
  methods: {
    ...mapFilters(['brandSlug', 'vendorCodeSlug']),
    href4Item(part) {
      const url = ['/poisk-po-nomeru'];
      url.push(this.brandSlug(part.brand));
      url.push(this.vendorCodeSlug(part.vendor_code));
      return url.join('/');
    },
  },
};
</script>

<style lang="postcss">
  .gridCounterparts {
    & > .header {
      padding-bottom: .5rem;
    }

    ._fullSEOPath {
      display: none;
    }

    @media screen and (max-width: 980px) {
      & > .header {
        padding: 0.9375rem 1.25rem 1.25rem 1.25rem;
      }
    }

    .table.tableAnalogs {
      .th, .td {
        &._img {
          grid-area: img;
        }

        &._brand {
          grid-area: brand;
        }

        &._vendorCode {
          grid-area: vendorCode;
        }

        &._partName {
          grid-area: partName;
        }

        &._price {
          grid-area: price;
        }

        &._sellerCounterLocal {
          grid-area: sellerCounterLocal;
          align-items: center;
          text-align: center;
        }

        &._sellerCounterAll {
          grid-area: sellerCounterAll;
          align-items: center;
          text-align: center;
        }

        &._topMobile {
          grid-area: topMobile;
        }
      }

      .tr:first-child .td {
        border-top: none;
      }

      &._no-city {
        .th, .td {
          &._sellerCounterLocal {
            display: none;
          }
        }
      }

      & .badge {
        margin-top: 0.5rem;
        width: 100%;
        color: var(--bg-main);

        & > span {
          display: inline-block;
          padding: .25rem .5rem;
          border-radius: .25rem;
          background-color: var(--online-color);
          white-space: nowrap;
        }
      }

      .picture {
        padding-top: 5.375rem;
        background-color: var(--bg-lightest);

        .svg {
          width: 2.5rem;
          height: auto;
          fill: var(--fill-light);
        }
      }

      .buttonSellerCounter {
        width: 100%;
        white-space: nowrap;
      }

      .valueIsMobile {
        display: none;
      }

      .noResult {
        font-weight: var(--font-weight-medium);
      }

      @media screen and (min-width: 981px) {
        &._no-city {
          .tr {
            grid-template-columns:
              6rem 0.75fr 0.75fr 1fr 0.75fr 12rem;
            grid-template-areas: "img brand vendorCode partName price sellerCounterAll";
          }
        }

        .tr {
          grid-template-columns:
            6rem 12rem 0.75fr 1fr 0.75fr 12rem 12rem;
          grid-template-areas:
            "img brand vendorCode partName price sellerCounterLocal sellerCounterAll";

          .th {
            min-height: auto;
          }
        }

        .th._topMobile,
        .td._topMobile {
          display: none;
        }

        .td {
          display: flex;
          flex-direction: column;
          justify-content: center;
        }

        .td._img {
          padding: 0;
          border-right: 1px solid var(--border-color-main);
        }

        .td._price {
          font-size: 1rem;
          font-weight: var(--font-weight-bold);
          text-align: right;
        }
        .td._brand {
          font-weight: var(--font-weight-medium);
          /*.link {*/
          /*  color: var(--color-main);*/
          /*  &:hover {*/
          /*    color: var(--link-hover-color);*/
          /*  }*/
          /*}*/
        }

        .td._applicability {
          color: var(--color-main-lightest);
          .buttonAsLink {
            display: inline-block;
            margin-left: -1.375rem;
            width: 4rem;
            font-size: inherit;
            text-align: right;
            background-image: linear-gradient(270deg,var(--bg-main) 2.5rem, var(--bg-transparent));
          }
        }

        .td._sellerCounterLocal,
        .td._sellerCounterAll {
          justify-content: center;
          .buttonSellerCounter {
            width: 100%;
          }
        }

        .noResult {
          font-weight: var(--font-weight-medium);
        }

        .__hide-shadow {
          margin-right: -2rem;
        }

        .buttonSellerCounter {
          white-space: nowrap;
        }
      }

      @media (min-width: 981px) and (max-width: 1200px) {
        &._no-city {
          .tr {
            grid-template-columns: 6.5rem 1fr 1fr 0.75fr 12rem;
            grid-template-areas:
              "img brand partName price sellerCounterAll"
              "img vendorCode partName price sellerCounterAll";
            grid-auto-rows: auto 1fr;
          }
        }

        .tr {
          grid-template-columns:
            6.5rem 1fr 0.85fr 12rem 12rem;
          grid-template-areas:
            "img brand price sellerCounterLocal sellerCounterAll"
            "img vendorCode price sellerCounterLocal sellerCounterAll"
            "img  partName price sellerCounterLocal sellerCounterAll";
          grid-template-rows: auto auto 1fr;
        }
        .td {
          justify-content: flex-start;
        }

        &:not(._no-city) {
          .th._partName, .td._partName {
            padding-top: 0;
            border-top: none;
          }
          .th._vendorCode, .td._vendorCode {
            padding-bottom: 0;
          }
        }

        .th._brand, .td._brand {
          padding-bottom: 0;
        }
        .th._vendorCode, .td._vendorCode {
          padding-top: 0;
          border-top: none;
        }

        .td._price {
          font-size: 1.125rem;
        }
        .__hide-shadow {
          margin-right: -1rem;
        }
        .badge {
          margin-top: 0.25rem;
          margin-bottom: 0.25rem;
          & > span {
            padding: .15rem .3rem;
            font-size: 12px;
          }
        }
      }

      @media screen and (max-width: 980px) {

        ._fullSEOPath {
          display: block;
        }

        ._fullSEOPath + .__hide-shadow.__no-wrap {
          display: none;
        }

        &:not(._no-city) {
          .td._sellerCounterAll {
            margin-top: 1.25rem;
            text-align: left;
            .buttonSellerCounter {
              display: inline-block;
              padding: 0;
              width: auto;
              height: auto;
              min-height: auto;
              font-size: 1rem;
              color: var(--link-color);
              background-color: transparent;
              border: none;
              box-shadow: none;
            }
            .valueIsMobile {
              display: inline-block;
              padding-right: .25rem;
              font-size: 1rem;
              font-weight: var(--font-weight-medium);
            }
          }
        }

        .tr {
          grid-template-columns: auto 6.625rem;
          grid-template-rows: auto auto 1fr;
          grid-template-areas:
            "topMobile topMobile"
            "brand img"
            "partName img"
            "price img"
            "sellerCounterLocal sellerCounterLocal"
            "sellerCounterAll sellerCounterAll"
        }

        .td._topMobile {
          display: flex;
          justify-content: space-between;
          padding-bottom: 0.625rem;
          font-size: 0.875rem;
        }
        .td._img {
          padding-left: 1rem;
        }
        .td._price {
          padding-bottom: 1.25rem;
          font-size: 1.5rem;
          font-weight: var(--font-weight-bold);
        }
        .td._brand {
          padding-bottom: 0.25rem;
          font-size: 1.125rem;
          font-weight: var(--font-weight-bold);
          .valueIsMobile {
            display: inline;
          }
        }
        .td._partName {
          padding-bottom: .625rem;
          font-size: 1rem;
        }
        .td._vendorCode,
        .td._applicability {
          display: none;
        }
        .td._sellerCounterLocal {
          margin-top: 1.25rem;
          .buttonSellerCounter {
            width: 100%;
            border: none;
            background-color: var(--btn-bg);
          }
        }

        .buttonOutlineColor {
          background-color: var(--btn-bg);
          border: none;
          box-shadow: none;
        }

        .picture {
          padding-top: 5.625rem;

          > .svg {
            width: 2.5rem;
          }
        }

        .__hide-shadow:after {
          content: none;
        }

        .badge {
          margin-top: 0.25rem;
          margin-bottom: 0.25rem;
          & > span {
            padding: .25rem .5rem;
            font-size: 14px;
          }
        }
      }
    }
  }
</style>
